<?php

$table = "articles";
$mysqli = new mysqli("localhost", "root", "", "posts");
$mysqli->set_charset("utf8");
$stmt = $mysqli->stmt_init();

function get_posts($id = false)
{
	global $table;
	global $mysqli;
	global $stmt;

	$where_statment = "";
	$rows = [];

	if (!empty($id)) {
		if (is_row_exits($id)) {
			$where_statment = "WHERE id=?";
		} else
			return $rows;
	}

	$query = "SELECT * FROM `{$table}` {$where_statment} ORDER BY id DESC";

	$stmt->prepare($query);

	if (!empty($where_statment)) {
		$stmt->bind_param("i", $id);
	}

	if ($stmt->execute() && $res = $stmt->get_result()) {
		if ($stmt->affected_rows || $res->num_rows) {
			while ($row_loop = $res->fetch_assoc()) {
				$rows[] = $row_loop;
			}
		}
	}

	return $rows;
}

function is_row_exits($id)
{

	global $table;
	global $mysqli;
	global $stmt;

	$query = "SELECT id FROM {$table} WHERE id=?";

	$stmt->prepare($query);

	$stmt->bind_param('i', $id);

	$is_found = 0;

	if ($stmt->execute() && $stmt->store_result()) {
		$is_found = $stmt->affected_rows;
		$stmt->free_result();
	}

	return $is_found;
}

function set_post_stars($post_id, $score)
{

	global $table;

	global $stmt;

	$row_updated = false;

	$query = "UPDATE {$table} SET `rstar` = `rstar` + ? , `rstar_user` = `rstar_user` + 1 WHERE `id`=?";

	$stmt->prepare($query);

	$stmt->bind_param('ii', $score, $post_id);

	if ($stmt->execute()) {
		$row_updated = $stmt->affected_rows ? $stmt->affected_rows : 1;
	}

	return $row_updated;
}

function set_post_stars_cookie(&$user_review_content_cookie, &$response_list)
{
	$res = set_post_stars($_POST['post_id'], $_POST['post_score']);

	if (!$res) die(["msg" => "خطایی در ارتباط با پایگاه داده رخ داده است", "status" => 0]);

	$post = get_posts($_POST['post_id']);
	$post = end($post);
	$post = ["star"=> ($post['rstar'] / $post['rstar_user']) , "user"=> $post['rstar_user'] , "id" => $post['id']];
	
	$response_list["data"] = $post;
	$response_list["msg"] = "امتیاز {$_POST['post_score']} با موفقیت ثبت گردید";
	$response_list["status"] = 1;

	array_push($user_review_content_cookie['post_id'], $_POST['post_id']);
	setcookie("post_review_stars", json_encode($user_review_content_cookie), time() + 86400); // تا 1 روز آینده
}
