document.addEventListener("DOMContentLoaded", function () {


    const starElmentDOM = document.getElementsByClassName("stars-shape");
    let requestLock = false;

    const starDOM = document.getElementsByClassName("star");
    for (var i = 0; i < starDOM.length; i++) {
        const currentElement = starDOM[i];


        currentElement.addEventListener("mouseover", handlerFillStars)

        currentElement.addEventListener("click", function (event) {

            const currentElementParent = currentElement.parentElement;
            const postID = currentElementParent.getAttribute("data-post-id");
            const score = parseInt(currentElement.getAttribute("data-item-number"));

            reviewRequest(postID, score);

        })


    }

    for (var i = 0; i < starElmentDOM.length; i++) {
        const currentElement = starElmentDOM[i];
        currentElement.addEventListener("mouseleave", handlerEmptyStars)
    }

    // handlers

    function handlerFillStars(event) {
        handlerEmptyStars();
        const currentElement = this;
        const currentElementParent = currentElement.parentElement;
        const currentElementItemNumber = currentElement.getAttribute("data-item-number");
        for (var i = 0; i < currentElementItemNumber; i++) {
            const currentElement = currentElementParent.querySelector("#star" + (i + 1));
            if (currentElement == null) continue;

            currentElement.style.fill = "#bc8f07";
        }

    }

    function handlerEmptyStars(event) {

        for (var j = 0; j < starDOM.length; j++) {
            const currentElement = starDOM[j];
            currentElement.removeAttribute("style");
        }
    }

    // ajax Request

    function reviewRequest(postID, postScore, currentElement) {

        if (requestLock)
            return;

        const xhr = new XMLHttpRequest();
        xhr.responseType = "json";

        requestLock = true;

        const params = new FormData;
        params.append("post_id", postID);
        params.append("post_score", postScore);

        xhr.open("POST", location.href + "/review-api.php");

        xhr.onload = function () {
            requestLock = false;
            const response = this.response;

            if (response.status == 1) {
     
                
                let starsNumber = response.data.star;
                const reviewerNumber = response.data.user;
                const postID = response.data.id;
                
                const starWrapper = document.querySelector("article#post-" + postID + " .stars-shape")
                
                let parentElementPreviousElement = starWrapper.previousElementSibling;
                if(!parentElementPreviousElement){
                    parentElementPreviousElement = document.createElement("span");
                    parentElementPreviousElement.id = "stars-number";
                    parentElementPreviousElement.innerHTML = '<i id="rate">x1</i> از <i id="avg-count">x2</i> رای';
                    starWrapper.parentElement.insertBefore(parentElementPreviousElement , starWrapper);
                }
                
                // مقداردهی نوشته رای
                parentElementPreviousElement.querySelector("#rate").textContent = starsNumber.toFixed(1);
                parentElementPreviousElement.querySelector("#avg-count").textContent = reviewerNumber;

                // پرکردن مجدد ستاره ها
                const svgStar = starWrapper.querySelectorAll("svg");
                
                var starTempValue = 0;
                var currentElement = null;
                for(var i=0;i<svgStar.length;i++){
                    currentElement = svgStar[i];
                    starTempValue = 1 < starsNumber ? 1 : starsNumber.toFixed(1);
                    starTempValue *= 100;
                    currentElement.querySelector("#half-stp-1").setAttribute("offset" , starTempValue + "%");
                    starsNumber--;
                }
                
            }

            alert(response.msg);
        }

        xhr.onerror = function () {
            requestLock = false;
            console.warn("[XHR Error]");
        }

        xhr.send(params);

    }
});